Index: /palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4535)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -1516,5 +1519,5 @@
        WRITE ( 14 )  average_trigger_mrt
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io( 'do_average_theta', do_average_theta )
@@ -1555,5 +1558,5 @@
        ENDIF
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !
Index: /palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4533 2020-05-14 14:46:46Z schwenkel
 ! Reformat intrinsic function
 ! 
@@ -3742,5 +3745,5 @@
           WRITE ( 14 )  ice_crystal_sedimentation
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
           CALL wrd_mpi_io( 'c_sedimentation', c_sedimentation )
@@ -3865,5 +3868,5 @@
           ENDIF
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
           IF ( ALLOCATED( prr ) )  CALL wrd_mpi_io( 'prr', prr )
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 4534)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unneccessary query for restart data format removed
+! 
+! 4534 2020-05-14 18:35:22Z raasch
 ! adjustments for I/O on reduced number of cores using shared memory MPI
 ! 
@@ -284,12 +287,4 @@
        message_string = 'illegal restart data output format "' //                                  &
                         TRIM( restart_data_format_output ) // '"'
-       CALL message( 'check_parameters', 'PA....', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( ( TRIM( restart_data_format_input ) == 'mpi_shared_memory'  .AND.                         &
-           TRIM( restart_data_format_output ) /= 'mpi_shared_memory' )  .OR.                       &
-         ( TRIM( restart_data_format_input ) /= 'mpi_shared_memory'  .AND.                         &
-           TRIM( restart_data_format_output ) == 'mpi_shared_memory' ) )  THEN
-       message_string = 'restart data formats both must be set "mpi_shared_memory"'
        CALL message( 'check_parameters', 'PA....', 1, 2, 0, 6, 0 )
     ENDIF
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4535)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO
 ! 
@@ -3250,5 +3253,5 @@
        ENDDO
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        DO  lsp = 1, nspec
Index: /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90
===================================================================
--- /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4518 2020-05-04 15:44:28Z suehring
 ! * Define arrays over ghost points in order to allow for standard mpi-io 
 !   treatment. By this modularization of restart-data input is possible with
@@ -2273,5 +2276,5 @@
        ENDIF
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        IF ( ALLOCATED( pt_2m_av ) )     CALL wrd_mpi_io( 'pt_2m_av', pt_2m_av )
Index: /palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- /palm/trunk/SOURCE/gust_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/gust_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -727,5 +730,5 @@
 !          ENDIF
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !          CALL wrd_mpi_io( 'global_parameter', global_parameter )
@@ -757,5 +760,5 @@
 !          ENDIF
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !          IF ( ALLOCATED( u2_av ) )  CALL wrd_mpi_io( 'u2_av', u2_av )
Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4520 2020-05-06 08:57:19Z schwenkel
 ! Add error number
 ! 
@@ -3229,5 +3232,5 @@
        WRITE ( 14 )  iran, iran_part
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io( 'iran', iran )  ! matching random numbers is still unresolved issue
@@ -3260,5 +3263,5 @@
        WRITE ( 14 )  interpolation_trilinear
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io( 'curvature_solution_effects', curvature_solution_effects )
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4534 2020-05-14 18:35:22Z raasch
 ! bugfix for switching on restart data output with MPI-IO
 ! 
@@ -6663,5 +6666,5 @@
        ENDDO
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        IF ( ALLOCATED( c_liq_av ) )  CALL wrd_mpi_io( 'c_liq_av',  c_liq_av )
Index: /palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ocean_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/ocean_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -2202,5 +2205,5 @@
        WRITE ( 14 )  wave_breaking
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io( 'bc_sa_t', bc_sa_t )
@@ -2252,5 +2255,5 @@
        ENDIF
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        IF ( ALLOCATED( rho_ocean_av ) )  CALL wrd_mpi_io( 'rho_ocean_av', rho_ocean_av )
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 4534)
+++ /palm/trunk/SOURCE/palm.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4496 2020-04-15 08:37:26Z raasch
 ! bugfix: coupling character added to restart output filename
 ! 
@@ -432,5 +435,5 @@
           ENDDO
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 !
 !--       Open MPI-IO restart file
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 4534)
+++ /palm/trunk/SOURCE/parin.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4505 2020-04-20 15:37:15Z schwenkel
 ! Add flag for saturation check
 ! 
@@ -511,5 +514,6 @@
 !--          input needs to be set now! This is normally done later in check parameters.
              IF ( TRIM( restart_data_format ) /= 'fortran_binary'  .AND.                           &
-                  TRIM( restart_data_format ) /= 'mpi' )  THEN
+                  TRIM( restart_data_format ) /= 'mpi'             .AND.                           &
+                  TRIM( restart_data_format ) /= 'mpi_shared_memory' )  THEN
                 message_string = 'illegal restart data format "' // TRIM( restart_data_format ) // '"'
                 CALL message( 'parin', 'PA....', 1, 2, 0, 6, 0 )
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4535)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4525 2020-05-10 17:05:07Z raasch
 ! bugfix for reading/writing pcm_...rate_av with MPI-IO
 ! 
@@ -2577,5 +2580,5 @@
           WRITE ( 14 )  pch_index
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
           CALL wrd_mpi_io( 'pch_index', pch_index )
@@ -2612,5 +2615,5 @@
           ENDIF
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4535)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4531 2020-05-13 09:52:22Z moh.hefny
 ! Bugfix in gather flux pabs_pc_lwdif in non_parallel case
 !
@@ -12081,5 +12084,5 @@
        ENDIF
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        IF ( ALLOCATED( rad_net_av ) )  CALL wrd_mpi_io( 'rad_net_av', rad_net_av )
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4535)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4527 2020-05-11 09:39:55Z monakurppa
 ! Correct a bug in salsa_wrd_global and salsa_check_data_output,
 ! and add reglim to be read/written in the restart data
@@ -3402,5 +3405,5 @@
        WRITE ( 14 )  reglim
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        DO  i = 1, 7
@@ -3527,5 +3530,5 @@
        ENDIF
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        ALLOCATE( tmp_3d(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
Index: /palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -4954,5 +4957,5 @@
           WRITE ( 14 )  average_count_surf
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
          CALL wrd_mpi_io( 'average_count_surf', average_count_surf )
@@ -4979,5 +4982,5 @@
           ENDIF
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
           IF ( ALLOCATED( surfaces%var_av ) )  CALL wrd_mpi_io( 'surfaces%var_av', surfaces%var_av )
Index: /palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/surface_mod.f90	(revision 4535)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4521 2020-05-06 11:39:49Z schwenkel
 ! Rename variable
 ! 
@@ -3955,5 +3958,5 @@
           ENDDO
 
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -1269,5 +1272,5 @@
        WRITE ( 14 )  use_syn_turb_gen
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io( 'time_stg_adjust', time_stg_adjust )
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4535)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -8660,5 +8663,5 @@
        ENDDO
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 !
 !--    There is no information about the PE-grid necessary because the restart files consists of the
Index: /palm/trunk/SOURCE/user_module.f90
===================================================================
--- /palm/trunk/SOURCE/user_module.f90	(revision 4534)
+++ /palm/trunk/SOURCE/user_module.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 !
@@ -1241,5 +1244,5 @@
 !       WRITE ( 14 )  global_parameter
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !    CALL rrd_mpi_io( 'global_parameter', global_parameter )
@@ -1270,5 +1273,5 @@
 !       ENDIF
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
 !       IF ( ALLOCATED( u2_av ) )  CALL wrd_mpi_io( 'u2_av', u2_av )
Index: /palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 4535)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4522 2020-05-06 14:17:05Z suehring
 ! Modularize user_init_flight in order to provide an explicit interface.
 ! 
@@ -1112,5 +1115,5 @@
        WRITE ( 14 )  z_pos
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io_global_array( 'u_agl', u_agl )
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4535)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4528 2020-05-11 14:14:09Z oliver.maas
 ! added namelist parameter smearing_kernel_size
 ! 
@@ -610,5 +613,5 @@
        WRITE ( 14 )  torque_gen_old
 
-    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 
        CALL wrd_mpi_io_global_array( 'generator_speed', generator_speed )
Index: /palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4534)
+++ /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4535)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! bugfix for restart data format query
+! 
+! 4514 2020-04-30 16:29:59Z suehring
 ! qsurf and ssurf added
 ! 
@@ -876,5 +879,5 @@
        WRITE ( 14 )  z_i
 
-    ELSEIF ( restart_data_format_output == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 !
 !--    Write global restart data using MPI-IO
@@ -1471,5 +1474,5 @@
        ENDIF
 
-    ELSEIF ( restart_data_format_output == 'mpi' )  THEN
+    ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
 !
 !--    Write local restart data using MPI-IO